package io.gitlab.jfronny.muscript.data;

import io.gitlab.jfronny.commons.data.ImmCollection;
import io.gitlab.jfronny.muscript.data.dynamic.*;

import java.util.HashMap;
import java.util.Map;

public class Scope implements DObject {
    private final DObject source;
    private final Map<String, Dynamic<?>> override = new HashMap<>();

    public Scope() {
        this(DFinal.of(Map.of()));
    }

    public Scope(DObject source) {
        this.source = source;
    }

    @Override
    public Map<String, Dynamic<?>> getValue() {
        var map = new HashMap<>(source.getValue());
        map.putAll(override);
        return ImmCollection.of(map);
    }

    public Scope set(String key, Dynamic<?> value) {
        override.put(key, value);
        return this;
    }

    public Scope fork() {
        return new Scope(this);
    }
}
