package io.gitlab.jfronny.muscript.test;

import io.gitlab.jfronny.muscript.ast.StringExpr;
import io.gitlab.jfronny.muscript.ast.dynamic.Assign;
import io.gitlab.jfronny.muscript.ast.literal.StringLiteral;
import io.gitlab.jfronny.muscript.compiler.Parser;
import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.muscript.test.util.UnforkableScope;
import org.junit.jupiter.api.*;

import static org.junit.jupiter.api.Assertions.*;

class AssignTest {
    @Test
    void testAssignSimple() {
        StringExpr expr = Parser.parse("someval = 'test'").asStringExpr();
        assertEquals(new Assign(0, 6, "someval", new StringLiteral(10, 15, "test").asDynamicExpr()).asStringExpr(), expr);
        Scope scope = new UnforkableScope();
        assertEquals("test", expr.get(scope));
        assertEquals("test", scope.getValue().get("someval").asString().getValue());
    }
}
